/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGShading;

import dstep.corefoundation.CFBase;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGColorSpace;
import dstep.applicationservices.coregraphics.CGFunction;
import dstep.applicationservices.coregraphics.CGGeometry;

struct CGShading;

alias CGShading* CGShadingRef;

extern (C)
{
	uint CGShadingGetTypeID ();
	CGShadingRef CGShadingCreateAxial (CGColorSpaceRef colorspace, CGPoint start, CGPoint end, CGFunctionRef function_, bool extendStart, bool extendEnd);
	CGShadingRef CGShadingCreateRadial (CGColorSpaceRef colorspace, CGPoint start, CGFloat startRadius, CGPoint end, CGFloat endRadius, CGFunctionRef function_, bool extendStart, bool extendEnd);
	CGShadingRef CGShadingRetain (CGShadingRef shading);
	void CGShadingRelease (CGShadingRef shading);
}