/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.CoreDataErrors;

import dstep.coredata.CoreDataDefines;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

import bindings = dstep.coredata.CoreDataErrors_bindings;

private
{
	NSString NSDetailedErrorsKey_;
	NSString NSValidationObjectErrorKey_;
	NSString NSValidationKeyErrorKey_;
	NSString NSValidationPredicateErrorKey_;
	NSString NSValidationValueErrorKey_;
	NSString NSAffectedStoresErrorKey_;
	NSString NSAffectedObjectsErrorKey_;
	NSString NSSQLiteErrorDomain_;
}

NSString NSDetailedErrorsKey ()
{
	if (NSDetailedErrorsKey_)
		return NSDetailedErrorsKey_;

	return NSDetailedErrorsKey_ = new NSString(bindings.NSDetailedErrorsKey);
}

NSString NSValidationObjectErrorKey ()
{
	if (NSValidationObjectErrorKey_)
		return NSValidationObjectErrorKey_;

	return NSValidationObjectErrorKey_ = new NSString(bindings.NSValidationObjectErrorKey);
}

NSString NSValidationKeyErrorKey ()
{
	if (NSValidationKeyErrorKey_)
		return NSValidationKeyErrorKey_;

	return NSValidationKeyErrorKey_ = new NSString(bindings.NSValidationKeyErrorKey);
}

NSString NSValidationPredicateErrorKey ()
{
	if (NSValidationPredicateErrorKey_)
		return NSValidationPredicateErrorKey_;

	return NSValidationPredicateErrorKey_ = new NSString(bindings.NSValidationPredicateErrorKey);
}

NSString NSValidationValueErrorKey ()
{
	if (NSValidationValueErrorKey_)
		return NSValidationValueErrorKey_;

	return NSValidationValueErrorKey_ = new NSString(bindings.NSValidationValueErrorKey);
}

NSString NSAffectedStoresErrorKey ()
{
	if (NSAffectedStoresErrorKey_)
		return NSAffectedStoresErrorKey_;

	return NSAffectedStoresErrorKey_ = new NSString(bindings.NSAffectedStoresErrorKey);
}

NSString NSAffectedObjectsErrorKey ()
{
	if (NSAffectedObjectsErrorKey_)
		return NSAffectedObjectsErrorKey_;

	return NSAffectedObjectsErrorKey_ = new NSString(bindings.NSAffectedObjectsErrorKey);
}

NSString NSSQLiteErrorDomain ()
{
	if (NSSQLiteErrorDomain_)
		return NSSQLiteErrorDomain_;

	return NSSQLiteErrorDomain_ = new NSString(bindings.NSSQLiteErrorDomain);
}

enum
{
	NSManagedObjectValidationError = 1550,
	NSValidationMultipleErrorsError = 1560,
	NSValidationMissingMandatoryPropertyError = 1570,
	NSValidationRelationshipLacksMinimumCountError = 1580,
	NSValidationRelationshipExceedsMaximumCountError = 1590,
	NSValidationRelationshipDeniedDeleteError = 1600,
	NSValidationNumberTooLargeError = 1610,
	NSValidationNumberTooSmallError = 1620,
	NSValidationDateTooLateError = 1630,
	NSValidationDateTooSoonError = 1640,
	NSValidationInvalidDateError = 1650,
	NSValidationStringTooLongError = 1660,
	NSValidationStringTooShortError = 1670,
	NSValidationStringPatternMatchingError = 1680,
	NSManagedObjectContextLockingError = 132000,
	NSPersistentStoreCoordinatorLockingError = 132010,
	NSManagedObjectReferentialIntegrityError = 133000,
	NSManagedObjectExternalRelationshipError = 133010,
	NSManagedObjectMergeError = 133020,
	NSPersistentStoreInvalidTypeError = 134000,
	NSPersistentStoreTypeMismatchError = 134010,
	NSPersistentStoreIncompatibleSchemaError = 134020,
	NSPersistentStoreSaveError = 134030,
	NSPersistentStoreIncompleteSaveError = 134040,
	NSCoreDataError = 134060,
	NSPersistentStoreOperationError = 134070,
	NSPersistentStoreOpenError = 134080,
	NSPersistentStoreTimeoutError = 134090,
	NSPersistentStoreIncompatibleVersionHashError = 134100,
	NSMigrationError = 134110,
	NSMigrationCancelledError = 134120,
	NSMigrationMissingSourceModelError = 134130,
	NSMigrationMissingMappingModelError = 134140,
	NSMigrationManagerSourceStoreError = 134150,
	NSMigrationManagerDestinationStoreError = 134160,
	NSEntityMigrationPolicyError = 134170,
	NSSQLiteError = 134180
}

