/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFFileDescriptor;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFRunLoop;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

alias int CFFileDescriptorNativeDescriptor;
struct __CFFileDescriptor;
alias __CFFileDescriptor* CFFileDescriptorRef;

extern (C)
{
	alias void function (CFFileDescriptorRef, uint, void*) CFFileDescriptorCallBack;
}

enum
{
	kCFFileDescriptorReadCallBack = 1 << 0,
	kCFFileDescriptorWriteCallBack = 1 << 1
}

struct CFFileDescriptorContext
{
	int version_;
	void* info;
}

extern (C)
{
	uint CFFileDescriptorGetTypeID ();
	CFFileDescriptorRef CFFileDescriptorCreate (CFAllocatorRef allocator, int fd, ubyte closeOnInvalidate, CFFileDescriptorCallBack* callout, CFFileDescriptorContext* context);
	int CFFileDescriptorGetNativeDescriptor (CFFileDescriptorRef f);
	void CFFileDescriptorGetContext (CFFileDescriptorRef f, CFFileDescriptorContext* context);
	void CFFileDescriptorEnableCallBacks (CFFileDescriptorRef f, uint callBackTypes);
	void CFFileDescriptorDisableCallBacks (CFFileDescriptorRef f, uint callBackTypes);
	void CFFileDescriptorInvalidate (CFFileDescriptorRef f);
	ubyte CFFileDescriptorIsValid (CFFileDescriptorRef f);
	CFRunLoopSourceRef CFFileDescriptorCreateRunLoopSource (CFAllocatorRef allocator, CFFileDescriptorRef f, int order);
}