/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTFormatDescription;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTKitDefines;

import bindings = dstep.qtkit.QTFormatDescription_bindings;

private
{
	NSString QTFormatDescriptionAudioStreamBasicDescriptionAttribute_;
	NSString QTFormatDescriptionAudioMagicCookieAttribute_;
	NSString QTFormatDescriptionAudioChannelLayoutAttribute_;
	NSString QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute_;
	NSString QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute_;
	NSString QTFormatDescriptionVideoEncodedPixelsSizeAttribute_;
}

NSString QTFormatDescriptionAudioStreamBasicDescriptionAttribute ()
{
	if (QTFormatDescriptionAudioStreamBasicDescriptionAttribute_)
		return QTFormatDescriptionAudioStreamBasicDescriptionAttribute_;

	return QTFormatDescriptionAudioStreamBasicDescriptionAttribute_ = new NSString(bindings.QTFormatDescriptionAudioStreamBasicDescriptionAttribute);
}

NSString QTFormatDescriptionAudioMagicCookieAttribute ()
{
	if (QTFormatDescriptionAudioMagicCookieAttribute_)
		return QTFormatDescriptionAudioMagicCookieAttribute_;

	return QTFormatDescriptionAudioMagicCookieAttribute_ = new NSString(bindings.QTFormatDescriptionAudioMagicCookieAttribute);
}

NSString QTFormatDescriptionAudioChannelLayoutAttribute ()
{
	if (QTFormatDescriptionAudioChannelLayoutAttribute_)
		return QTFormatDescriptionAudioChannelLayoutAttribute_;

	return QTFormatDescriptionAudioChannelLayoutAttribute_ = new NSString(bindings.QTFormatDescriptionAudioChannelLayoutAttribute);
}

NSString QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute ()
{
	if (QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute_)
		return QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute_;

	return QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute_ = new NSString(bindings.QTFormatDescriptionVideoCleanApertureDisplaySizeAttribute);
}

NSString QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute ()
{
	if (QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute_)
		return QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute_;

	return QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute_ = new NSString(bindings.QTFormatDescriptionVideoProductionApertureDisplaySizeAttribute);
}

NSString QTFormatDescriptionVideoEncodedPixelsSizeAttribute ()
{
	if (QTFormatDescriptionVideoEncodedPixelsSizeAttribute_)
		return QTFormatDescriptionVideoEncodedPixelsSizeAttribute_;

	return QTFormatDescriptionVideoEncodedPixelsSizeAttribute_ = new NSString(bindings.QTFormatDescriptionVideoEncodedPixelsSizeAttribute);
}

class QTFormatDescription : NSObject
{
	mixin (ObjcWrap);

	NSString mediaType ()
	{
		return invokeObjcSelf!(NSString, "mediaType");
	}

	uint formatType ()
	{
		return invokeObjcSelf!(uint, "formatType");
	}

	NSString localizedFormatSummary ()
	{
		return invokeObjcSelf!(NSString, "localizedFormatSummary");
	}

	NSDictionary formatDescriptionAttributes ()
	{
		return invokeObjcSelf!(NSDictionary, "formatDescriptionAttributes");
	}

	Object attributeForKey (NSString key)
	{
		return invokeObjcSelf!(Object, "attributeForKey:", NSString)(key);
	}

	bool isEqualToFormatDescription (QTFormatDescription formatDescription)
	{
		return invokeObjcSelf!(bool, "isEqualToFormatDescription:", QTFormatDescription)(formatDescription);
	}
}

