/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CATransform3D;

import dstep.applicationservices.coregraphics.CGAffineTransform;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.foundation.NSValue;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CABase;

extern (C)
{
	extern
	{
		const CATransform3D CATransform3DIdentity;
	}
}

struct CATransform3D
{
	CGFloat m11;
	CGFloat m12;
	CGFloat m13;
	CGFloat m14;
	CGFloat m21;
	CGFloat m22;
	CGFloat m23;
	CGFloat m24;
	CGFloat m31;
	CGFloat m32;
	CGFloat m33;
	CGFloat m34;
	CGFloat m41;
	CGFloat m42;
	CGFloat m43;
	CGFloat m44;
}

extern (C)
{
	bool CATransform3DIsIdentity (CATransform3D t);
	bool CATransform3DEqualToTransform (CATransform3D a, CATransform3D b);
	CATransform3D CATransform3DMakeTranslation (CGFloat tx, CGFloat ty, CGFloat tz);
	CATransform3D CATransform3DMakeScale (CGFloat sx, CGFloat sy, CGFloat sz);
	CATransform3D CATransform3DMakeRotation (CGFloat angle, CGFloat x, CGFloat y, CGFloat z);
	CATransform3D CATransform3DTranslate (CATransform3D t, CGFloat tx, CGFloat ty, CGFloat tz);
	CATransform3D CATransform3DScale (CATransform3D t, CGFloat sx, CGFloat sy, CGFloat sz);
	CATransform3D CATransform3DRotate (CATransform3D t, CGFloat angle, CGFloat x, CGFloat y, CGFloat z);
	CATransform3D CATransform3DConcat (CATransform3D a, CATransform3D b);
	CATransform3D CATransform3DInvert (CATransform3D t);
	CATransform3D CATransform3DMakeAffineTransform (CGAffineTransform m);
	bool CATransform3DIsAffine (CATransform3D t);
	CGAffineTransform CATransform3DGetAffineTransform (CATransform3D t);
}